/* A Bison parser, made by GNU Bison 3.0.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         __cc_algo_parser_parse
#define yylex           __cc_algo_parser_lex
#define yyerror         __cc_algo_parser_error
#define yydebug         __cc_algo_parser_debug
#define yynerrs         __cc_algo_parser_nerrs

#define yylval          __cc_algo_parser_lval
#define yychar          __cc_algo_parser_char

/* Copy the first part of user declarations.  */
#line 1 "./osm_cc_algo_parser_y.y" /* yacc.c:339  */

/*
 * Copyright (c) 2022-2023 NVIDIA CORPORATION & AFFILIATES. All rights reserved.
 *
 * This software is available to you under a choice of one of two
 * licenses.  You may choose to be licensed under the terms of the GNU
 * General Public License (GPL) Version 2, available from the file
 * COPYING in the main directory of this source tree, or the
 * OpenIB.org BSD license below:
 *
 *     Redistribution and use in source and binary forms, with or
 *     without modification, are permitted provided that the following
 *     conditions are met:
 *
 *      - Redistributions of source code must retain the above
 *        copyright notice, this list of conditions and the following
 *        disclaimer.
 *
 *      - Redistributions in binary form must reproduce the above
 *        copyright notice, this list of conditions and the following
 *        disclaimer in the documentation and/or other materials
 *        provided with the distribution.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
 * BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
 * ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
 * CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 *
 */

#include <stdio.h>
#include <string.h>
#include <stdarg.h>
#include <ctype.h>
#include <opensm/osm_file_ids.h>
#define FILE_ID OSM_FILE_CC_ALGO_PARSER_Y_Y
#include <opensm/osm_opensm.h>

#define YYSTYPE char * 
#define PPCC_ALGO_MAX_LINE_LEN             4096
#define PPCC_ALGO_ID_BITS_NUM              16
#define PPCC_ALGO_MAJOR_VERSION_BITS_NUM   8
#define PPCC_ALGO_MINOR_VERSION_BITS_NUM   8

typedef struct ppcc_algo_tmp_parser_struct_ {
	cl_list_t  str_list;
	cl_list_t  num_list;
	osm_ppcc_dictionary_entry_t dictionary_array[PPCC_ALGO_MAX_PARAMS];
	int current_index_in_dictionary;
	ib_ppcc_algo_info_t version;
	osm_ppcc_dictionary_entry_t entry;
	char file_name[PPCC_ALGO_MAX_FILE_NAME];
} ppcc_algo_tmp_parser_struct_t;

typedef enum ca_algo_conf_id {
	CA_ALGO_CONFIG_NAME,
	CA_ALGO_CONFIG_VERSION,
	CA_ALGO_CONFIG_PARAMS_NAME_LIST,
	CA_ALGO_CONFIG_PARAMS_MIN_VALS,
	CA_ALGO_CONFIG_PARAMS_MAX_VALS,
	CA_ALGO_CONFIG_LAST,
} ca_algo_conf_id_t;

typedef enum algo_conf_kind {
	CONF_CA_ALGO,
} algo_conf_kind_t;

extern FILE * __cc_algo_parser_in;
extern char *trim_whitespace(char *str);
extern void __cc_algo_parser_restart(FILE *input_file);

static struct osm_opensm *p_osm;
boolean_t ca_algo_conf_tags_parsed[CA_ALGO_CONFIG_LAST];

char *__cc_algo_parser_yylval = NULL;

ppcc_algo_tmp_parser_struct_t ppcc_algo_tmp_parser_struct;

int cc_algo_column_num;
int cc_algo_line_num;

osm_cc_ca_algo_conf_t *p_current_ca_algo_conf = NULL;


static void parser_tmp_struct_init(char *file_name)
{
	ppcc_algo_tmp_parser_struct.entry.str[0] = '\0';
	ppcc_algo_tmp_parser_struct.current_index_in_dictionary = 0;
	memcpy(ppcc_algo_tmp_parser_struct.file_name, file_name,
	       strlen(file_name) + 1);
	cl_list_construct(&ppcc_algo_tmp_parser_struct.str_list);
	cl_list_init(&ppcc_algo_tmp_parser_struct.str_list, 10);
	cl_list_construct(&ppcc_algo_tmp_parser_struct.num_list);
	cl_list_init(&ppcc_algo_tmp_parser_struct.num_list, 10);
}

/*
 * Do NOT free objects from the temp struct.
 * Either they are inserted into the parse tree data
 * structure, or they are already freed when copying
 * their values to the parse tree data structure.
 */
static void parser_tmp_struct_reset()
{
	ppcc_algo_tmp_parser_struct.entry.str[0] = '\0';
	ppcc_algo_tmp_parser_struct.current_index_in_dictionary = 0;
	cl_list_remove_all(&ppcc_algo_tmp_parser_struct.str_list);
	cl_list_remove_all(&ppcc_algo_tmp_parser_struct.num_list);
}

static void parser_tmp_struct_destroy()
{
	parser_tmp_struct_reset();
	cl_list_destroy(&ppcc_algo_tmp_parser_struct.str_list);
	cl_list_destroy(&ppcc_algo_tmp_parser_struct.num_list);
}

static void clear_val(char **c)
{
	free(*c);
	*c = NULL;
}

static void yyerror(const char *format, ...)
{
    char s[256];
    va_list pvar;

    OSM_LOG_ENTER(&p_osm->log);

    va_start(pvar, format);
    vsnprintf(s, sizeof(s), format, pvar);
    va_end(pvar);

    OSM_LOG(&p_osm->log, OSM_LOG_ERROR, "ERR 9E09: "
            "Syntax error (line %d:%d): %s\n",
            cc_algo_line_num, cc_algo_column_num, s);
    fprintf(stderr, "Error in CC Algo Policy File (line %d:%d): %s.\n",
            cc_algo_line_num, cc_algo_column_num, s);
    OSM_LOG_EXIT(&p_osm->log);
}

const char *get_ca_algo_param_name_by_id(int param_id)
{
	switch (param_id) {
	case CA_ALGO_CONFIG_NAME:
		return "ca_algo_name";
	case CA_ALGO_CONFIG_VERSION:
		return "ca_algo_version";
	case CA_ALGO_CONFIG_PARAMS_NAME_LIST:
		return "ca_algo_config_params_name_list";
	case CA_ALGO_CONFIG_PARAMS_MIN_VALS:
		return "ca_algo_config_params_min_vals";
	case CA_ALGO_CONFIG_PARAMS_MAX_VALS:
		return "ca_algo_config_params_max_vals";
	default:
		break;
	}

	return "unknown";
}

static const char *cc_algo_get_param_name_by_id(algo_conf_kind_t algo_conf_kind, int param_id)
{
	switch (algo_conf_kind) {
	case CONF_CA_ALGO:
		return get_ca_algo_param_name_by_id(param_id);
	default:
		break;
	}

	return "unknown";
}

static int are_all_params_defined(algo_conf_kind_t algo_conf_kind, boolean_t *params_def, int array_size)
{
	int param_id = 0;

	for (; param_id < array_size; param_id++) {
		if (!params_def[param_id]) {
			yyerror("Param %s is missing",
				cc_algo_get_param_name_by_id(algo_conf_kind, param_id));
			return 0;
		}
	}

	return 1;
}

static void clear_params_defined(boolean_t *params_def, int array_size)
{
	int param_id = 0;

	for (; param_id < array_size; param_id++) {
		params_def[param_id] = FALSE;
	}
}

static void mark_tag_parsed(boolean_t *params_id_array, int array_size,
			    int param_id, const char *param_name)
{
	/* Ignore wrong param ids */
	if (param_id >= array_size)
		return;

	params_id_array[param_id] = TRUE;
}

static inline void mark_ca_algo_tag_parsed(int param_id) {
	mark_tag_parsed(ca_algo_conf_tags_parsed, CA_ALGO_CONFIG_LAST, param_id,
		        get_ca_algo_param_name_by_id(param_id));
}

static int is_tag_parsed(boolean_t *params_id_array, int array_size,
			 int param_id, const char *param_name)
{
	if (param_id >= array_size) {
		yyerror("The param %s has a bigger id %d than the array size",
			param_name, param_id);
		return 1;
	}

	if (params_id_array[param_id]) {
		yyerror("The param %s is already defined. Ignore current parsing "
			"of the param", param_name);
		return 1;
	}

	return 0;

}

static inline int is_ca_algo_tag_parsed(int param_id)
{
	return is_tag_parsed(ca_algo_conf_tags_parsed, CA_ALGO_CONFIG_LAST,
			     param_id, get_ca_algo_param_name_by_id(param_id));
}

static int validate_boolean(uint64_t param, char *name)
{
	if (param != FALSE && param != TRUE) {
		yyerror("%s has invalid value: %llu for a boolean", name, param);
		return 1;
	}

	return 0;
}


static int validate_param_size_by_bits_num(uint64_t param_value,
					   uint8_t bits_num, char *name)
{
	uint64_t max_size = ((uint64_t)1 << bits_num) - 1;

	if (bits_num == 1)
		return validate_boolean(param_value, name);

	if (param_value > max_size) {
		yyerror("The value: %llu of %s is too big, max size is: %llu",
			param_value, name, max_size);
		return 1;
	}

	return 0;
}

static osm_cc_ca_algo_conf_t *create_ca_algo_conf()
{
	osm_cc_ca_algo_conf_t *p_ca_algo_conf = NULL;
	cl_fmap_item_t *p_item;

	p_ca_algo_conf = calloc(1, sizeof(osm_cc_ca_algo_conf_t));
	if (!p_ca_algo_conf) {
		OSM_LOG(&p_osm->log, OSM_LOG_ERROR, "ERR 9E03: "
			"Failed allocating memory for new CA algo conf\n");
		goto Exit;
	}

	memcpy(p_ca_algo_conf->file_name, ppcc_algo_tmp_parser_struct.file_name,
	       strlen(ppcc_algo_tmp_parser_struct.file_name) + 1);

	p_item = cl_fmap_insert(&p_osm->sm.cc_mgr.ca_algo_conf,
				&p_ca_algo_conf->file_name,
				&p_ca_algo_conf->fmap_item);
	if (p_item != &p_ca_algo_conf->fmap_item) {
		OSM_LOG(&p_osm->log, OSM_LOG_ERROR, "ERR 9E04: "
			"Fail to add CA Algo conf, file name: %s of CA Algo "
			"already exist\n", p_ca_algo_conf->file_name);
		free(p_ca_algo_conf);
		p_ca_algo_conf = NULL;
		goto Exit;
	}

	cl_fmap_init(&p_ca_algo_conf->param_name_to_index, ppcc_algo_compare_param_names);
Exit:
	return p_ca_algo_conf;
}

static int ppcc_insert_to_index_map(char *name, int index)
{
	osm_cc_algo_param_index_t *p_algo_param_index = NULL;
	osm_cc_algo_param_index_t *p_map_algo_param_index = NULL;
	cl_fmap_item_t *p_item;
	int ret = 0;

	p_algo_param_index = calloc(1, sizeof(osm_cc_algo_param_index_t));
	if (!p_algo_param_index) {
		OSM_LOG(&p_osm->log, OSM_LOG_ERROR,
			"ERR 9E05: Failed to allocate p_algo_param_index\n");
		return 1;
	}

	p_algo_param_index->param_index = index;
	memcpy(p_algo_param_index->param_name, name, sizeof(p_algo_param_index->param_name));

	p_item = cl_fmap_insert(&p_current_ca_algo_conf->param_name_to_index,
				&p_algo_param_index->param_name,
				&p_algo_param_index->fmap_item);
	if (p_item != &p_algo_param_index->fmap_item) {
		p_map_algo_param_index = (osm_cc_algo_param_index_t *) p_item;
		if (p_algo_param_index->param_index != p_map_algo_param_index->param_index) {
			OSM_LOG(&p_osm->log, OSM_LOG_ERROR,
				"ERR 9E06: Already in map: our index: %d, index in map: %d, %p\n",
				p_algo_param_index->param_index, p_map_algo_param_index->param_index, p_algo_param_index); 
			ret = 1;
		}

		free(p_algo_param_index);
	}

	return ret;
}

static int ppcc_parse_param_list(int param_id)
{
	osm_cc_algo_param_t *p_algo_param;
	int ret = 0;
	int i;

	if (!p_current_ca_algo_conf) {
		ret = 1;
		goto Exit;
	}

	if (is_ca_algo_tag_parsed(param_id))
		goto Exit;

	mark_ca_algo_tag_parsed(param_id);

	if (!p_current_ca_algo_conf->param_num) {
		p_current_ca_algo_conf->param_num = ppcc_algo_tmp_parser_struct.current_index_in_dictionary;
	} else if (p_current_ca_algo_conf->param_num != ppcc_algo_tmp_parser_struct.current_index_in_dictionary) {
		ret = 1;
		goto Exit;;
	}

	for (i = 0; i < ppcc_algo_tmp_parser_struct.current_index_in_dictionary; i++) {
		p_algo_param = &p_current_ca_algo_conf->algo_param_list[i];
		if (ppcc_insert_to_index_map(ppcc_algo_tmp_parser_struct.dictionary_array[i].str, i)) {
			ret = 1;
			goto Exit;
		}

		switch (param_id) {
		case CA_ALGO_CONFIG_PARAMS_NAME_LIST:
			memcpy(p_algo_param->param_name, ppcc_algo_tmp_parser_struct.dictionary_array[i].str,
			       sizeof(ppcc_algo_tmp_parser_struct.dictionary_array[i].str));
			       p_algo_param->value = ppcc_algo_tmp_parser_struct.dictionary_array[i].value;
			break;
		case CA_ALGO_CONFIG_PARAMS_MIN_VALS:
			p_algo_param->min_value = ppcc_algo_tmp_parser_struct.dictionary_array[i].value;
			break;
		case CA_ALGO_CONFIG_PARAMS_MAX_VALS:
			p_algo_param->max_value = ppcc_algo_tmp_parser_struct.dictionary_array[i].value;
			break;
		default:
			ret = 1;
			goto Exit;
		}
	}

Exit:
	ppcc_algo_tmp_parser_struct.current_index_in_dictionary = 0;

	return ret;
}

int __cc_algo_parser_parse();
int __cc_algo_parser_lex();
void __cc_algo_parser_lex_destroy();

int parse_ppcc_algo_file(struct osm_opensm *osm_ptr, char *file_path, char *file_name)
{
	int res = 0;
	p_osm = osm_ptr;
	__cc_algo_parser_in = NULL;
	parser_tmp_struct_init(file_name);
	cc_algo_line_num = 0;
	cc_algo_column_num = 0;

	if (!file_path) {
		OSM_LOG(&p_osm->log, OSM_LOG_ERROR,
			"ERR 9E00: No PPCC algo file provided - Quit PPCC algo parser\n");
		res = 1;
		goto Exit;
	}

	__cc_algo_parser_in = fopen(file_path, "r");
	if (!__cc_algo_parser_in) {
		OSM_LOG(&p_osm->log, OSM_LOG_ERROR,
			"ERR 9E01: PPCC algo file specified but not found: %s\n", file_path);
		res = 1;
		goto Exit;
	}

        res =  __cc_algo_parser_parse();
	if (res) {
		OSM_LOG(&p_osm->log, OSM_LOG_ERROR,
			"ERR 9E02: PPCC algo file '%s' parsing failed\n", file_path);
		osm_cc_mgr_destroy(&p_osm->sm.cc_mgr);
	} else {
		OSM_LOG(&p_osm->log, OSM_LOG_DEBUG, "Congestion control Algo "
			"file parsed successfully\n");
	}

Exit:
	if (__cc_algo_parser_in) {
		__cc_algo_parser_restart(__cc_algo_parser_in);
		fclose(__cc_algo_parser_in);
		__cc_algo_parser_in = NULL;
	}
	clear_val(&__cc_algo_parser_yylval);
	parser_tmp_struct_destroy();
	__cc_algo_parser_lex_destroy();
	return res;
}


#line 517 "./osm_cc_algo_parser_y.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "osm_cc_algo_parser_y.h".  */
#ifndef YY__CC_ALGO_PARSER_OSM_CC_ALGO_PARSER_Y_H_INCLUDED
# define YY__CC_ALGO_PARSER_OSM_CC_ALGO_PARSER_Y_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int __cc_algo_parser_debug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    COMMENT = 258,
    COMMA = 259,
    DOT = 260,
    LEFT_BRACKET = 261,
    RIGHT_BRACKET = 262,
    LEFT_PARENTHESIS = 263,
    RIGHT_PARENTHESIS = 264,
    WORD = 265,
    GROUP = 266,
    EXNUMBER = 267,
    NUMBER = 268,
    CA_ALGO_START = 269,
    CA_ALGO_END = 270,
    ALGO_NAME = 271,
    ALGO_VERSION = 272,
    ALGO_RELEASE_DATE = 273,
    ALGO_DESCRIPTION = 274,
    ALGO_AUTHOR = 275,
    ALGO_SUPPORTED_DEVICES = 276,
    ALGO_VERSION_HASH = 277,
    PPCC_PARAMETER_NAME_LIST = 278,
    PPCC_PARAMETER_MIN_VALS = 279,
    PPCC_PARAMETER_MAX_VALS = 280
  };
#endif
/* Tokens.  */
#define COMMENT 258
#define COMMA 259
#define DOT 260
#define LEFT_BRACKET 261
#define RIGHT_BRACKET 262
#define LEFT_PARENTHESIS 263
#define RIGHT_PARENTHESIS 264
#define WORD 265
#define GROUP 266
#define EXNUMBER 267
#define NUMBER 268
#define CA_ALGO_START 269
#define CA_ALGO_END 270
#define ALGO_NAME 271
#define ALGO_VERSION 272
#define ALGO_RELEASE_DATE 273
#define ALGO_DESCRIPTION 274
#define ALGO_AUTHOR 275
#define ALGO_SUPPORTED_DEVICES 276
#define ALGO_VERSION_HASH 277
#define PPCC_PARAMETER_NAME_LIST 278
#define PPCC_PARAMETER_MIN_VALS 279
#define PPCC_PARAMETER_MAX_VALS 280

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef int YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE __cc_algo_parser_lval;

int __cc_algo_parser_parse (void);

#endif /* !YY__CC_ALGO_PARSER_OSM_CC_ALGO_PARSER_Y_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 618 "./osm_cc_algo_parser_y.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  3
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   28

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  26
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  24
/* YYNRULES -- Number of rules.  */
#define YYNRULES  34
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  52

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   280

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   474,   474,   476,   477,   480,   482,   483,   484,   488,
     491,   492,   495,   496,   497,   498,   499,   500,   503,   511,
     542,   552,   563,   572,   582,   592,   597,   602,   607,   610,
     611,   614,   632,   637,   646
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "COMMENT", "COMMA", "DOT",
  "LEFT_BRACKET", "RIGHT_BRACKET", "LEFT_PARENTHESIS", "RIGHT_PARENTHESIS",
  "WORD", "GROUP", "EXNUMBER", "NUMBER", "CA_ALGO_START", "CA_ALGO_END",
  "ALGO_NAME", "ALGO_VERSION", "ALGO_RELEASE_DATE", "ALGO_DESCRIPTION",
  "ALGO_AUTHOR", "ALGO_SUPPORTED_DEVICES", "ALGO_VERSION_HASH",
  "PPCC_PARAMETER_NAME_LIST", "PPCC_PARAMETER_MIN_VALS",
  "PPCC_PARAMETER_MAX_VALS", "$accept", "cc_policy", "configurations",
  "comment", "configuration", "ca_algo", "ca_algo_entries",
  "ca_algo_entry", "ca_algo_start", "ca_algo_end", "ca_algo_name",
  "ca_algo_version", "algo_id", "algo_major", "algo_minor",
  "ca_algo_ppcc_parameter_name_list",
  "ca_algo_ppcc_parameter_min_vals_list",
  "ca_algo_ppcc_parameter_max_vals_list", "dictionary", "entries", "entry",
  "entry_str", "entry_value", "word", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280
};
# endif

#define YYPACT_NINF -16

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-16)))

#define YYTABLE_NINF -1

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int8 yypact[] =
{
     -16,     3,     1,   -16,   -16,   -16,   -16,   -16,   -16,   -16,
     -16,   -16,    -3,   -16,    -9,    -5,     4,     4,     4,   -16,
     -16,   -16,   -16,   -16,   -16,   -16,   -16,   -16,   -16,    11,
       9,   -16,   -16,   -16,    -4,     8,    -2,   -16,   -16,    14,
     -16,    19,     9,   -16,    12,    13,   -16,   -16,   -16,   -16,
      15,   -16
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       3,     0,     2,     1,     5,    34,    18,     8,     4,     6,
      10,     7,     0,    19,     0,     0,     0,     0,     0,    17,
      11,     9,    12,    13,    14,    15,    16,    20,    22,     0,
       0,    25,    26,    27,     0,     0,     0,    29,    23,     0,
      32,     0,     0,    28,     0,     0,    30,    24,    21,    33,
       0,    31
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int8 yypgoto[] =
{
     -16,   -16,   -16,    16,   -16,   -16,   -16,   -16,   -16,   -16,
     -16,   -16,   -16,   -16,   -16,   -16,   -16,   -16,   -11,   -16,
     -15,   -16,   -16,   -16
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int8 yydefgoto[] =
{
      -1,     1,     2,     7,     8,     9,    12,    20,    10,    21,
      22,    23,    29,    39,    48,    24,    25,    26,    31,    36,
      37,    41,    50,    11
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_uint8 yytable[] =
{
       4,    27,    42,     3,     4,    43,    32,    33,    28,    38,
      30,     5,    13,    14,    15,     6,    34,    35,    40,    44,
      16,    17,    18,    45,    51,    47,    49,    46,    19
};

static const yytype_uint8 yycheck[] =
{
       3,    10,     4,     0,     3,     7,    17,    18,    13,    13,
       6,    10,    15,    16,    17,    14,     5,     8,    10,     5,
      23,    24,    25,     4,     9,    13,    13,    42,    12
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,    27,    28,     0,     3,    10,    14,    29,    30,    31,
      34,    49,    32,    15,    16,    17,    23,    24,    25,    29,
      33,    35,    36,    37,    41,    42,    43,    10,    13,    38,
       6,    44,    44,    44,     5,     8,    45,    46,    13,    39,
      10,    47,     4,     7,     5,     4,    46,    13,    40,    13,
      48,     9
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    26,    27,    28,    28,    29,    30,    30,    30,    31,
      32,    32,    33,    33,    33,    33,    33,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      45,    46,    47,    48,    49
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     0,     2,     1,     1,     1,     1,     3,
       0,     2,     1,     1,     1,     1,     1,     1,     1,     1,
       2,     6,     1,     1,     1,     2,     2,     2,     3,     1,
       3,     5,     1,     1,     1
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                                              );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);

        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 5:
#line 480 "./osm_cc_algo_parser_y.y" /* yacc.c:1646  */
    {}
#line 1732 "./osm_cc_algo_parser_y.c" /* yacc.c:1646  */
    break;

  case 18:
#line 503 "./osm_cc_algo_parser_y.y" /* yacc.c:1646  */
    {
	p_current_ca_algo_conf = create_ca_algo_conf();
	if (!p_current_ca_algo_conf)
		return 1;

	clear_params_defined(ca_algo_conf_tags_parsed, CA_ALGO_CONFIG_LAST);
}
#line 1744 "./osm_cc_algo_parser_y.c" /* yacc.c:1646  */
    break;

  case 19:
#line 511 "./osm_cc_algo_parser_y.y" /* yacc.c:1646  */
    {
	osm_cc_algo_param_t *p_algo_param;
	int i;

	if (!are_all_params_defined(CONF_CA_ALGO, ca_algo_conf_tags_parsed, CA_ALGO_CONFIG_LAST))
		return 1;

	for (i = 0; i < p_current_ca_algo_conf->param_num; i++){
		p_algo_param = &p_current_ca_algo_conf->algo_param_list[i];

		if (p_algo_param->max_value < p_algo_param->min_value) {
			OSM_LOG(&p_osm->log, OSM_LOG_ERROR,
				"ERR 9E10: The default min_value of algo param '%s': "
				"%u is bigger then the max value in the allowed range %u\n",
				p_algo_param->param_name, p_algo_param->min_value,
				p_algo_param->max_value);
			return 1;
		}

		if (p_algo_param->value < p_algo_param->min_value ||
		    p_algo_param->max_value < p_algo_param->value) {
			OSM_LOG(&p_osm->log, OSM_LOG_ERROR,
				"ERR 9E11: The default value of algo param '%s': "
				"%u is not in the allowed range %u-%u\n",
				p_algo_param->param_name, p_algo_param->value,
				p_algo_param->min_value, p_algo_param->max_value);
			return 1;
		}
	}
}
#line 1779 "./osm_cc_algo_parser_y.c" /* yacc.c:1646  */
    break;

  case 20:
#line 542 "./osm_cc_algo_parser_y.y" /* yacc.c:1646  */
    {
	if (!p_current_ca_algo_conf)
		return 1;

	if (!is_ca_algo_tag_parsed(CA_ALGO_CONFIG_NAME)) {
		snprintf(p_current_ca_algo_conf->name, sizeof(p_current_ca_algo_conf->name),
			 "%s", __cc_algo_parser_yylval);
		mark_ca_algo_tag_parsed(CA_ALGO_CONFIG_NAME);
	}
}
#line 1794 "./osm_cc_algo_parser_y.c" /* yacc.c:1646  */
    break;

  case 21:
#line 552 "./osm_cc_algo_parser_y.y" /* yacc.c:1646  */
    {
	if (!p_current_ca_algo_conf)
		return 1;

	if (!is_ca_algo_tag_parsed(CA_ALGO_CONFIG_VERSION)) {
		memcpy(&p_current_ca_algo_conf->algo_version, &ppcc_algo_tmp_parser_struct.version,
		       sizeof(ppcc_algo_tmp_parser_struct.version));
		mark_ca_algo_tag_parsed(CA_ALGO_CONFIG_VERSION);
	}
}
#line 1809 "./osm_cc_algo_parser_y.c" /* yacc.c:1646  */
    break;

  case 22:
#line 563 "./osm_cc_algo_parser_y.y" /* yacc.c:1646  */
    {
	uint64_t algo_id = strtoull(__cc_algo_parser_yylval, NULL, 0);

	if (validate_param_size_by_bits_num(algo_id, PPCC_ALGO_ID_BITS_NUM, "algo_id"))
		return 1;

	ppcc_algo_tmp_parser_struct.version.algo_id = cl_hton16(algo_id);
}
#line 1822 "./osm_cc_algo_parser_y.c" /* yacc.c:1646  */
    break;

  case 23:
#line 572 "./osm_cc_algo_parser_y.y" /* yacc.c:1646  */
    {
	uint64_t algo_major = strtoull(__cc_algo_parser_yylval, NULL, 0);

	if (validate_param_size_by_bits_num(algo_major, PPCC_ALGO_MAJOR_VERSION_BITS_NUM,
					    "algo_major"))
		return 1;

	ppcc_algo_tmp_parser_struct.version.algo_major_version = algo_major;
}
#line 1836 "./osm_cc_algo_parser_y.c" /* yacc.c:1646  */
    break;

  case 24:
#line 582 "./osm_cc_algo_parser_y.y" /* yacc.c:1646  */
    {
	uint64_t algo_minor = strtoull(__cc_algo_parser_yylval, NULL, 0);

	if (validate_param_size_by_bits_num(algo_minor, PPCC_ALGO_MINOR_VERSION_BITS_NUM,
					    "algo_minor"))
		return 1;

	ppcc_algo_tmp_parser_struct.version.algo_minor_version = algo_minor;
}
#line 1850 "./osm_cc_algo_parser_y.c" /* yacc.c:1646  */
    break;

  case 25:
#line 592 "./osm_cc_algo_parser_y.y" /* yacc.c:1646  */
    {
	if (ppcc_parse_param_list(CA_ALGO_CONFIG_PARAMS_NAME_LIST))
		return 1;
}
#line 1859 "./osm_cc_algo_parser_y.c" /* yacc.c:1646  */
    break;

  case 26:
#line 597 "./osm_cc_algo_parser_y.y" /* yacc.c:1646  */
    {
	if (ppcc_parse_param_list(CA_ALGO_CONFIG_PARAMS_MIN_VALS))
		return 1;
}
#line 1868 "./osm_cc_algo_parser_y.c" /* yacc.c:1646  */
    break;

  case 27:
#line 602 "./osm_cc_algo_parser_y.y" /* yacc.c:1646  */
    {
	if (ppcc_parse_param_list(CA_ALGO_CONFIG_PARAMS_MAX_VALS))
		return 1;
}
#line 1877 "./osm_cc_algo_parser_y.c" /* yacc.c:1646  */
    break;

  case 31:
#line 614 "./osm_cc_algo_parser_y.y" /* yacc.c:1646  */
    {
	osm_ppcc_dictionary_entry_t *dictionary_entry = NULL;

	if (ppcc_algo_tmp_parser_struct.current_index_in_dictionary >= PPCC_ALGO_MAX_PARAMS) {
		OSM_LOG(&p_osm->log, OSM_LOG_ERROR,
			"ERR 9E07: Couldn't parse dictionary of PPCC algo parameters, "
			"max number of parameters is %d\n", PPCC_ALGO_MAX_PARAMS);
		return 1;
	}

	dictionary_entry =
	    &ppcc_algo_tmp_parser_struct.dictionary_array[ppcc_algo_tmp_parser_struct.current_index_in_dictionary];

	memcpy(dictionary_entry->str, ppcc_algo_tmp_parser_struct.entry.str, sizeof(ppcc_algo_tmp_parser_struct.entry.str));
	dictionary_entry->value = ppcc_algo_tmp_parser_struct.entry.value;
	ppcc_algo_tmp_parser_struct.current_index_in_dictionary++;
}
#line 1899 "./osm_cc_algo_parser_y.c" /* yacc.c:1646  */
    break;

  case 32:
#line 632 "./osm_cc_algo_parser_y.y" /* yacc.c:1646  */
    {
	memcpy(ppcc_algo_tmp_parser_struct.entry.str, __cc_algo_parser_yylval,
	       strlen(__cc_algo_parser_yylval) + 1);
}
#line 1908 "./osm_cc_algo_parser_y.c" /* yacc.c:1646  */
    break;

  case 33:
#line 637 "./osm_cc_algo_parser_y.y" /* yacc.c:1646  */
    {
	uint64_t tmp = strtoull(__cc_algo_parser_yylval, NULL, 0);

	if (tmp > UINT32_MAX)
		yyerror("The value %llu is to big. The max value is %u\n", UINT32_MAX);

	ppcc_algo_tmp_parser_struct.entry.value = tmp;
}
#line 1921 "./osm_cc_algo_parser_y.c" /* yacc.c:1646  */
    break;

  case 34:
#line 646 "./osm_cc_algo_parser_y.y" /* yacc.c:1646  */
    {
	OSM_LOG(&p_osm->log, OSM_LOG_ERROR, "ERR 9E08: Unexpected "
		"input |%.200s|, Aborting parsing!\n", __cc_algo_parser_yylval);
	return 1;
}
#line 1931 "./osm_cc_algo_parser_y.c" /* yacc.c:1646  */
    break;


#line 1935 "./osm_cc_algo_parser_y.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
